Package ghidra.app.util.bin.format.elf

# Class GnuVerdef

java.lang.Object
ghidra.app.util.bin.format.elf.GnuVerdef

All Implemented Interfaces:
  `StructConverter`

public class GnuVerdef extends Object implements StructConverter
Version definition sections.

     typedef struct {
       Elf32_Half   vd_version;             //Version revision
       Elf32_Half   vd_flags;               //Version information
       Elf32_Half   vd_ndx;                 //Version Index
       Elf32_Half   vd_cnt;                 //Number of associated aux entries
       Elf32_Word   vd_hash;                //Version name hash value
       Elf32_Word   vd_aux;                 //Offset in bytes to verdaux array
       Elf32_Word   vd_next;                //Offset in bytes to next verdef entry
     } Elf32_Verdef;

     typedef struct {
       Elf64_Half   vd_version;             //Version revision
       Elf64_Half   vd_flags;               //Version information
       Elf64_Half   vd_ndx;                 //Version Index
       Elf64_Half   vd_cnt;                 //Number of associated aux entries
       Elf64_Word   vd_hash;                //Version name hash value
       Elf64_Word   vd_aux;                 //Offset in bytes to verdaux array
       Elf64_Word   vd_next;                //Offset in bytes to next verdef entry
     } Elf64_Verdef;

- ## Field Summary

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getAux()`
  `short`
  `getCnt()`
  `short`
  `getFlags()`
  `int`
  `getHash()`
  `short`
  `getNdx()`
  `int`
  `getNext()`
  `short`
  `getVersion()`
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### getVersion

    public short getVersion()

  - ### getFlags

    public short getFlags()

  - ### getNdx

    public short getNdx()

  - ### getCnt

    public short getCnt()

  - ### getHash

    public int getHash()

  - ### getAux

    public int getAux()

  - ### getNext

    public int getNext()

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Specified by:
      `toDataType` in interface `StructConverter`
    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException`
    See Also:
      - `StructConverter.toDataType()`